<?php
namespace Claromentis\Core\Security;

$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] ?: array()) + array("_77649368bc532d9bc06d" . "dad8a50096a2" => base64_decode("QXBwbGljYXRpb24gcmVxdWlyZXMgYWRtaW4gY" . "WNjZXNzLCBidXQgZG9lc24ndCBzcGVjaWZ5IH" . "BhbmVsIGNvZGU="), "_d5e3acfe493" . "fa2111d22dfb" . "93da33d87" => base64_decode("X1" . "8="), "_fdd279667944aa31b47cee7c44" . "88495f" => base64_decode("JywgYnV0IGl0J3" . "Mgbm90IGdpdmVu"), "_965e72db2455ea911677" . "9414f062746a" => base64_decode("WW91IG5lZWQgdG8gY2hh" . "bmdlIHlvdXIgcGFzc3dv" . "cmQ="), "_24e0e36600d6a" . "f77406a44bb618" . "a6253" => base64_decode("dXNlc" . "g=="), "_7adf80c15f5376" . "37512f7766d5fa0" . "b2f" => base64_decode("c2VjdXJpdHkubW" . "9kZQ=="), "_7f628626" . "dd1d55c71" . "b1fc0932f" . "fd1d2c" => base64_decode("aXNfYXJyY" . "Xk="), "_5269083028d2f37d24843e7b56" . "f80025" => base64_decode("c2VjdXJpdH" . "kucmVzdHJp" . "Y3Rpb24="), "_6a11dd42eb3818bd" . "9995b593e850c7ea" => base64_decode("Rm9yY2VkIHB" . "hc3N3b3JkIG" . "NoYW5nZQ=="), "_8059e2bac" . "e3311190b0" . "a85f8709f7" . "a6a" => base64_decode("YWRtaW4" . "="), "_858e845b028b701406de2d" . "127009c941" => base64_decode("cGFuZWxfY29" . "kZQ=="), "_0521fbd3b745045e76" . "44213cbed21a21" => base64_decode("c2VjdXJpdHk" . "uZXh0cmE="), "_cc6b63c64fd515a5b0" . "110d3b97a814eb" => base64_decode("QXV0aGVudGljYXRpb24gcmVxdWlyZW" . "Q="), "_4dc7dd1d" . "92608d7c4" . "edca7dabd" . "0206ce" => base64_decode("b25LZXJuZWxGaW5pc2hSZXF1" . "ZXN0"), "_14feb73099827a30c31c0b" . "996c13f13c" => base64_decode("b25LZXJ" . "uZWxSZX" . "F1ZXN0"), "_6f8bc3b51" . "b049d89dac" . "de43983139" . "a56" => base64_decode("X3J" . "vdX" . "Rl"), "_c7a35cdd863" . "753e83240fbb" . "3e732a6b7" => base64_decode("bm9uZQ=" . "="), "_5ce040a" . "e4c22329" . "c2682c36" . "8b68b361" . "1" => base64_decode("UmVxdWV" . "zdGVkIG" . "FjY2Vzc" . "yAn"));
use Claromentis\Core\Admin\CurrentPanel;
use Claromentis\Core\Event\EventSubscriberInterface;
use Claromentis\Core\Security\Exception\AccessDeniedException;
use Claromentis\Core\Security\Exception\AdminAccessDeniedException;
use Claromentis\Core\Security\Exception\AuthenticationException;
use Claromentis\Core\Security\Exception\BadCredentialsException;
use Claromentis\Core\Security\Exception\ForcedPasswordChangeException;
use Claromentis\Core\Security\Exception\InvalidConfigException;
use Psr\Log\LoggerInterface;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Symfony\Component\HttpKernel\Event\FinishRequestEvent;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\Routing\RouteCollection;






class Firewall implements EventSubscriberInterface
{
    protected $routes;
    protected $auth_mode_manager;
    protected $context;
    protected $dispatcher;
    protected $logger;
    protected $exception_listeners;
    public function __construct(RouteCollection $_6c20f4873f12c6bcced6c1dda9a06b86, AuthenticationModeManager $_f6b575597c272e12f16dc922e604c11d, SessionSecurityContext $context, EventDispatcherInterface $_b497ce6f2af10f67516aed0ecf34d8cf, LoggerInterface $logger = null, CurrentPanel $_777fee2a9f69c8905bdc4ffffa7d93cf = null)
    {
        $this->routes = $_6c20f4873f12c6bcced6c1dda9a06b86;
        $this->auth_mode_manager = $_f6b575597c272e12f16dc922e604c11d;
        $this->context = $context;
        $this->dispatcher = $_b497ce6f2af10f67516aed0ecf34d8cf;
        $this->logger = $logger;
        $this->current_panel = $_777fee2a9f69c8905bdc4ffffa7d93cf;
        $this->exception_listeners = new \SplObjectStorage();
    }
    
    
    
    
    public static function getSubscribedEvents()
    {
        return array(KernelEvents::REQUEST => array($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_14feb73099827a30c31c0b996c13f1" . "3c"], 8), KernelEvents::FINISH_REQUEST => $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_4dc7dd1d92608d7c4edca7dab" . "d0206ce"]);
    }
    public function onKernelFinishRequest(FinishRequestEvent $event)
    {
        $request = $event->getRequest();
        
        
        if (isset($this->exception_listeners[$request])) {
            
            
            $_ee62014f4ef50dbe8eb79b2406d87bc7 = $this->exception_listeners[$request];
            $_ee62014f4ef50dbe8eb79b2406d87bc7->unregister($this->dispatcher);
            unset($this->exception_listeners[$request]);
        }
    }
    
    
    
    
    
    
    
    
    
    protected function VerifyAccess(GetResponseEvent $event, $_601a171d59986f7c15972b586685671b, $_3de589dc8908aa0acc1d667051a758f3, $_4a033bdf0ce701c6255d5238633ab2d0)
    {
        $request = $event->getRequest();
        $_76b40b4ffb78489ccdf0fef0a81963f5 = $this->auth_mode_manager->GetExceptionListener($_601a171d59986f7c15972b586685671b);
        
        
        if (null !== $_76b40b4ffb78489ccdf0fef0a81963f5) {
            $this->exception_listeners[$request] = $_76b40b4ffb78489ccdf0fef0a81963f5;
            $_76b40b4ffb78489ccdf0fef0a81963f5->register($this->dispatcher);
        }
        if ($_3de589dc8908aa0acc1d667051a758f3 !== $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_c7a35cdd863" . "753e83240fbb" . "3e732a6b7"]) {
            $_b911cc8a777886afea194de4534beffa = $this->auth_mode_manager->GetAuthenticators($_601a171d59986f7c15972b586685671b);
            foreach ($_b911cc8a777886afea194de4534beffa as $_bcd36e5a5ed036659bc02cdfe807a094) {
                $_bcd36e5a5ed036659bc02cdfe807a094->Handle($event, $this->context);
                if ($event->hasResponse()) {
                    return;
                }
            }
        }
        $_34142f0805685e788bb54a01fb3e222c = null;
        if ($_3de589dc8908aa0acc1d667051a758f3 === $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_8059e2bace3311190" . "b0a85f8709f7a6a"]) {
            if (!$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_7f628626dd1d55c71b1fc09" . "32ffd1d2c"]($_4a033bdf0ce701c6255d5238633ab2d0) || empty($_4a033bdf0ce701c6255d5238633ab2d0[$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_858e845b028b701406de2d12700" . "9c941"]])) {
                throw new InvalidConfigException($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_77649368bc532d9bc" . "06ddad8a50096a2"]);
            }
            $_34142f0805685e788bb54a01fb3e222c = $_4a033bdf0ce701c6255d5238633ab2d0[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_858e845b028b" . "701406de2d127" . "009c941"]];
            $_3de589dc8908aa0acc1d667051a758f3 = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_24e0e36600d6af77406a44bb618a" . "6253"];
        }
        if (!$this->context->IsGranted($_3de589dc8908aa0acc1d667051a758f3)) {
            if (null !== $this->logger) {
                $this->logger->error($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_5ce040ae4c22329c2682c368b68" . "b3611"] . $_3de589dc8908aa0acc1d667051a758f3 . $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_fdd2796" . "67944aa3" . "1b47cee7" . "c4488495" . "f"], [$this->context]);
            }
            if (!$this->context->GetUserId()) {
                throw new AccessDeniedException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_cc6b63c64fd515a5b0110d3b97a81" . "4eb"], 401);
            }
            throw new AccessDeniedException();
        }
        if ($_34142f0805685e788bb54a01fb3e222c !== null) {
            if (!$this->context->GetUserId()) {
                throw new AccessDeniedException($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_cc6b63c64fd51" . "5a5b0110d3b97a" . "814eb"], 401);
            }
            if (!\AdminPanel::UserHasAccess($_34142f0805685e788bb54a01fb3e222c, $this->context->GetId())) {
                throw new AdminAccessDeniedException($_34142f0805685e788bb54a01fb3e222c);
            }
            if ($this->current_panel !== null) {
                $this->current_panel->Set($_34142f0805685e788bb54a01fb3e222c);
            }
        }
        $this->CheckPasswordPolicy();
    }
    
    
    
    
    
    
    
    
    public function onKernelRequest(GetResponseEvent $event)
    {
        if (!$event->isMasterRequest()) {
            return;
        }
        $request = $event->getRequest();
        $_d7cd24af9c1ec9e84b034650f4556bdc = $request->attributes->get($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_6f8bc3b51b049d89dacde43983" . "139a56"]);
        if (!($_4c24595e81e7e67a084f4708169b7ec6 = $this->routes->get($_d7cd24af9c1ec9e84b034650f4556bdc))) {
            return;
        }
        
        
        $_601a171d59986f7c15972b586685671b = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_7adf80c15f53" . "7637512f7766d" . "5fa0b2f"]);
        $_3de589dc8908aa0acc1d667051a758f3 = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_5269083028d2f37d" . "24843e7b56f80025"]);
        $_4a033bdf0ce701c6255d5238633ab2d0 = $_4c24595e81e7e67a084f4708169b7ec6->getOption($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_0521fbd3b745045" . "e7644213cbed21a2" . "1"]);
        $request->attributes->set($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_7adf80c15f53" . "7637512f7766d" . "5fa0b2f"], $_601a171d59986f7c15972b586685671b);
        $request->attributes->set($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_5269083028d2f37d24843e7b56f800" . "25"], $_3de589dc8908aa0acc1d667051a758f3);
        $request->attributes->set($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_0521fbd3b745" . "045e7644213cb" . "ed21a21"], $_4a033bdf0ce701c6255d5238633ab2d0);
        $this->VerifyAccess($event, $_601a171d59986f7c15972b586685671b, $_3de589dc8908aa0acc1d667051a758f3, $_4a033bdf0ce701c6255d5238633ab2d0);
    }
    
    
    
    
    protected function CheckPasswordPolicy()
    {
        
        
        
        try {
            StdAuthenticator::MODE_AJAX;
            
            
            AuthUserPasswordPolicy::Run();
        } catch (PageLoadHookRedirectException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            $this->logger->notice($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_6a11dd42eb3818" . "bd9995b593e850c" . "7ea"], [$_fe441aa3ef350bfb1a1a1ad8520dd530]);
            throw new ForcedPasswordChangeException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_d5e3acfe493f" . "a2111d22dfb93" . "da33d87"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_965e72db2455ea9116779414" . "f062746a"]));
        }
    }
}